﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace kr1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            NewComboBox();
        }

        private void infoToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Form2 about = new Form2();
            about.Show();
        }

        public void initDataGrid()
        {
            dataGridView1.Rows.Clear();
            dataGridView1.ColumnCount = 5;
            dataGridView1.Columns[0].HeaderText = "Номер";
            dataGridView1.Columns[1].HeaderText = "Назкание заказа";
            dataGridView1.Columns[2].HeaderText = "Фамилия";
            dataGridView1.Columns[3].HeaderText = "Имя";
            dataGridView1.Columns[4].HeaderText = "Описание";
            dataGridView1.Columns[0].AutoSizeMode = DataGridViewAutoSizeColumnMode.AllCells;
            dataGridView1.Columns[1].AutoSizeMode = DataGridViewAutoSizeColumnMode.AllCells;
            dataGridView1.Columns[2].AutoSizeMode = DataGridViewAutoSizeColumnMode.AllCells;
            dataGridView1.Columns[3].AutoSizeMode = DataGridViewAutoSizeColumnMode.AllCells;
            dataGridView1.Columns[4].AutoSizeMode = DataGridViewAutoSizeColumnMode.AllCells;
        }

        public void NewComboBox()
        {
            comboBox1.Items.Clear();
            comboBox1.Items.Add("Новая запись");
            for (int i = 0; i < dataGridView1.Rows.Count - 1; i++)
            {
                comboBox1.Items.Add(dataGridView1.Rows[i].Cells[1].Value.ToString());
            }

            if (comboBox1.Items.Count > 0)
                comboBox1.SelectedIndex = 0;
            else
            {
                comboBox1.Text = "";
                tbNum.Text = "";
                tbTitle.Text = "";
                tbFam.Text = "";
                tbNam.Text = "";
            }
        }

        private void readFileToolStripMenuItem_Click(object sender, EventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.RestoreDirectory = true;

            initDataGrid();

            if (ofd.ShowDialog() == DialogResult.OK)
            {
                try
                {
                    int cnt = 0;
                    StreamReader reader = new StreamReader(ofd.FileName);
                    string line;


                    while ((line = reader.ReadLine()) != null)
                    {
                        cnt++;
                        string[] separator = { ";" };
                        string[] data = line.Split(separator, StringSplitOptions.RemoveEmptyEntries);

                        if (dataGridView1.RowCount > 1 && data.Length == 1)
                        {
                            dataGridView1.Rows[dataGridView1.RowCount - 2].Cells[4].Value += " " + data[0];
                        }
                        else
                        {
                            if (data.Length == 5)
                            {
                                dataGridView1.Rows.Add(data[0], data[1], data[2], data[3], data[4]);
                            }
                        }
                    }
                    reader.Close();

                    NewComboBox();
                }
                catch (Exception ex)
                {
                    MessageBox.Show("Error: файл не может быть прочитан, оригинальная ошибка: " + ex.Message);
                }
            }
        }

        private void saveFileToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SaveFileDialog sfd = new SaveFileDialog();
            sfd.RestoreDirectory = true;

            if (sfd.ShowDialog() == DialogResult.OK)
            {
                try
                {
                    StreamWriter writer = new StreamWriter(sfd.FileName);
                    
                    for (int i = 0; i < dataGridView1.Rows.Count-1; i++)
                    {
                        string id = dataGridView1.Rows[i].Cells[0].Value.ToString();
                        string title = dataGridView1.Rows[i].Cells[1].Value.ToString();
                        string fam = dataGridView1.Rows[i].Cells[2].Value.ToString();
                        string nam = dataGridView1.Rows[i].Cells[3].Value.ToString();
                        string desc = dataGridView1.Rows[i].Cells[4].Value.ToString();
                        writer.WriteLine(id + ";" + title + ";" + fam + ";" + nam + ";" + desc);
                    }
                    writer.Close();
                }
                catch (Exception ex)
                {
                    MessageBox.Show("Error: файл не может быть прочитан, оригинальная ошибка: " + ex.Message);
                }
            }
        }

        private void btnPrev_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < dataGridView1.Rows.Count - 1; i++)
            {
                if (i > 0 && tbNum.Text.Equals(dataGridView1.Rows[i].Cells[0].Value.ToString()))
                {
                    tbNum.Text = dataGridView1.Rows[i - 1].Cells[0].Value.ToString();
                    tbTitle.Text = dataGridView1.Rows[i - 1].Cells[1].Value.ToString();
                    tbFam.Text = dataGridView1.Rows[i - 1].Cells[2].Value.ToString();
                    tbNam.Text = dataGridView1.Rows[i - 1].Cells[3].Value.ToString();
                    tbDesc.Text = dataGridView1.Rows[i - 1].Cells[4].Value.ToString();
                    break;
                }
            }
        }

        private void btnNext_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < dataGridView1.Rows.Count - 1; i++)
            {
                if (i < dataGridView1.Rows.Count-2 && tbNum.Text.Equals(dataGridView1.Rows[i].Cells[0].Value.ToString()))
                {
                    tbNum.Text = dataGridView1.Rows[i + 1].Cells[0].Value.ToString();
                    tbTitle.Text = dataGridView1.Rows[i + 1].Cells[1].Value.ToString();
                    tbFam.Text = dataGridView1.Rows[i + 1].Cells[2].Value.ToString();
                    tbNam.Text = dataGridView1.Rows[i + 1].Cells[3].Value.ToString();
                    tbDesc.Text = dataGridView1.Rows[i + 1].Cells[4].Value.ToString();
                    break;
                }
            }
        }

        private void btnSearch_Click(object sender, EventArgs e)
        {
            string search = tbSearchFam.Text.ToString();
            for (int i = 0; i < dataGridView1.Rows.Count - 1; i++)
            {
                if (search.Equals(dataGridView1.Rows[i].Cells[2].Value.ToString()))
                {
                    tbNum.Text = dataGridView1.Rows[i].Cells[0].Value.ToString();
                    tbTitle.Text = dataGridView1.Rows[i].Cells[1].Value.ToString();
                    tbFam.Text = dataGridView1.Rows[i].Cells[2].Value.ToString();
                    tbNam.Text = dataGridView1.Rows[i].Cells[3].Value.ToString();
                    tbDesc.Text = dataGridView1.Rows[i].Cells[4].Value.ToString();
                    break;
                }
            }
        }

        private void btnRemove_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < dataGridView1.Rows.Count - 1; i++)
            {
                if (tbNum.Text.Equals(dataGridView1.Rows[i].Cells[0].Value.ToString()))
                {
                    dataGridView1.Rows.RemoveAt(i);
                    break;
                }
            }
            NewComboBox();
        }


        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            for (int i = 0; i < dataGridView1.Rows.Count - 1; i++)
            {
                if (comboBox1.Text.Equals(dataGridView1.Rows[i].Cells[1].Value.ToString()))
                {
                    tbNum.Text = dataGridView1.Rows[i].Cells[0].Value.ToString();
                    tbTitle.Text = dataGridView1.Rows[i].Cells[1].Value.ToString();
                    tbFam.Text = dataGridView1.Rows[i].Cells[2].Value.ToString();
                    tbNam.Text = dataGridView1.Rows[i].Cells[3].Value.ToString();
                    tbDesc.Text = dataGridView1.Rows[i].Cells[4].Value.ToString();
                    break;
                }
            }
        }

        private void saveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (dataGridView1.Columns.Count == 5)
            {
                if (!comboBox1.Text.Equals("Новая запись"))
                {
                    for (int i = 0; i < dataGridView1.Rows.Count - 1; i++)
                    {
                        if (comboBox1.Text.Equals(dataGridView1.Rows[i].Cells[1].Value.ToString()))
                        {
                            dataGridView1.Rows[i].Cells[0].Value = tbNum.Text;
                            dataGridView1.Rows[i].Cells[1].Value = tbTitle.Text;
                            dataGridView1.Rows[i].Cells[2].Value = tbFam.Text;
                            dataGridView1.Rows[i].Cells[3].Value = tbNam.Text;
                            dataGridView1.Rows[i].Cells[4].Value = tbDesc.Text;
                            break;
                        }
                    }
                }
                else
                {
                    dataGridView1.Rows.Add(tbNum.Text, tbTitle.Text, tbFam.Text, tbNam.Text, tbDesc.Text);
                }
            }
            else
            {
                initDataGrid();

                dataGridView1.Rows.Add(tbNum.Text, tbTitle.Text, tbFam.Text, tbNam.Text, tbDesc.Text);
            }

            NewComboBox();
        }

        private void sortOnNumToolStripMenuItem_Click(object sender, EventArgs e)
        {
            sortData(0);
            NewComboBox();
        }

        private void sortOnTitleToolStripMenuItem_Click(object sender, EventArgs e)
        {
            sortData(1);
            NewComboBox();
        }

        private void sortOnFamToolStripMenuItem_Click(object sender, EventArgs e)
        {
            sortData(2);
            NewComboBox();
        }

        private void sortOnNameToolStripMenuItem_Click(object sender, EventArgs e)
        {
            sortData(3);
            NewComboBox();
        }

        public void sortData(int column = 0)
        {
            for (int i = 0; i < dataGridView1.Rows.Count - 1; i++)
            {
                for (int j = 0; j < dataGridView1.Rows.Count - 1 - i; j++)
                {
                    if (String.Compare(dataGridView1.Rows[j].Cells[column].Value.ToString(), dataGridView1.Rows[j + 1].Cells[column].Value.ToString()) > 0)
                    {
                        string id = dataGridView1.Rows[j].Cells[0].Value.ToString();
                        string title = dataGridView1.Rows[j].Cells[1].Value.ToString();
                        string fam = dataGridView1.Rows[j].Cells[2].Value.ToString();
                        string nam = dataGridView1.Rows[j].Cells[3].Value.ToString();
                        string desc = dataGridView1.Rows[j].Cells[4].Value.ToString();

                        dataGridView1.Rows[j].Cells[0].Value = dataGridView1.Rows[j + 1].Cells[0].Value;
                        dataGridView1.Rows[j].Cells[1].Value = dataGridView1.Rows[j + 1].Cells[1].Value;
                        dataGridView1.Rows[j].Cells[2].Value = dataGridView1.Rows[j + 1].Cells[2].Value;
                        dataGridView1.Rows[j].Cells[3].Value = dataGridView1.Rows[j + 1].Cells[3].Value;
                        dataGridView1.Rows[j].Cells[4].Value = dataGridView1.Rows[j + 1].Cells[4].Value;

                        dataGridView1.Rows[j + 1].Cells[0].Value = id;
                        dataGridView1.Rows[j + 1].Cells[1].Value = title;
                        dataGridView1.Rows[j + 1].Cells[2].Value = fam;
                        dataGridView1.Rows[j + 1].Cells[3].Value = nam;
                        dataGridView1.Rows[j + 1].Cells[4].Value = desc;
                        break;
                    }
                }
            }
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }
    }
}
